﻿namespace ProjectSeaplane
/// <summary>
/// Форма работы с объектом "Гидросамолет"
/// </summary>
{
    public partial class FormSeaplane : Form
    {
        /// <summary>
        /// Конструктор формы
        /// </summary>
        public FormSeaplane()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Поле-объект для прорисовки объекта
        /// </summary>
        private DrawingSeaplane? _drawingSeaplane;
        /// <summary>
        /// Метод прорисовки самолета
        /// </summary>
        private void Draw()
        {
            if (_drawingSeaplane == null)
            {
                return;
            }

            Bitmap bmp = new(pictureBoxSeaplane.Width, pictureBoxSeaplane.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingSeaplane.DrawTransport(gr);
            pictureBoxSeaplane.Image = bmp;
        }
        /// <summary>
        /// Обработка нажатия кнопки "Создать"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingSeaplane = new DrawingSeaplane();
            _drawingSeaplane.Init(random.Next(100, 300), random.Next(1000, 3000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
            _drawingSeaplane.SetPictureSize(pictureBoxSeaplane.Width, pictureBoxSeaplane.Height);
            _drawingSeaplane.SetPosition(random.Next(10, 100), random.Next(10, 100));

            Draw();
        }
        /// <summary>
        /// Перемещение объекта по форме (нажатие кнопок навигации)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawingSeaplane == null)
            {
                return;
            }

            string name = ((Button)sender)?.Name ?? string.Empty;
            bool result = false;
            switch (name)
            {
                case "buttonUp":
                    result = _drawingSeaplane.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    result = _drawingSeaplane.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    result = _drawingSeaplane.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    result = _drawingSeaplane.MoveTransport(DirectionType.Right);
                    break;
            }

            if (result)
            {
                Draw();
            }
        }


    }
}
